"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .chain import Chain
from .token_enum import TokenEnum
from compass_api_sdk.types import BaseModel
from compass_api_sdk.utils import validate_const
import pydantic
from pydantic.functional_validators import AfterValidator
from typing import Literal, Optional, Union
from typing_extensions import Annotated, TypeAliasType, TypedDict


OdosSwapRequestTokenInTypedDict = TypeAliasType(
    "OdosSwapRequestTokenInTypedDict", Union[TokenEnum, str]
)
r"""The symbol or address of the token that is to be sold."""


OdosSwapRequestTokenIn = TypeAliasType("OdosSwapRequestTokenIn", Union[TokenEnum, str])
r"""The symbol or address of the token that is to be sold."""


OdosSwapRequestTokenOutTypedDict = TypeAliasType(
    "OdosSwapRequestTokenOutTypedDict", Union[TokenEnum, str]
)
r"""The symbol or address of the token that is to be bought."""


OdosSwapRequestTokenOut = TypeAliasType(
    "OdosSwapRequestTokenOut", Union[TokenEnum, str]
)
r"""The symbol or address of the token that is to be bought."""


OdosSwapRequestAmountTypedDict = TypeAliasType(
    "OdosSwapRequestAmountTypedDict", Union[float, str]
)
r"""The amount of token_in to be sold."""


OdosSwapRequestAmount = TypeAliasType("OdosSwapRequestAmount", Union[float, str])
r"""The amount of token_in to be sold."""


class OdosSwapRequestTypedDict(TypedDict):
    token_in: OdosSwapRequestTokenInTypedDict
    r"""The symbol or address of the token that is to be sold."""
    token_out: OdosSwapRequestTokenOutTypedDict
    r"""The symbol or address of the token that is to be bought."""
    amount: OdosSwapRequestAmountTypedDict
    r"""The amount of token_in to be sold."""
    max_slippage_percent: float
    r"""The maximum slippage allowed in percent. e.g. `1` means `1%` slippage allowed."""
    chain: Chain
    r"""The chain to use."""
    sender: str
    r"""The address of the transaction sender."""
    action_type: Literal["ODOS_SWAP"]


class OdosSwapRequest(BaseModel):
    token_in: OdosSwapRequestTokenIn
    r"""The symbol or address of the token that is to be sold."""

    token_out: OdosSwapRequestTokenOut
    r"""The symbol or address of the token that is to be bought."""

    amount: OdosSwapRequestAmount
    r"""The amount of token_in to be sold."""

    max_slippage_percent: float
    r"""The maximum slippage allowed in percent. e.g. `1` means `1%` slippage allowed."""

    chain: Chain
    r"""The chain to use."""

    sender: str
    r"""The address of the transaction sender."""

    ACTION_TYPE: Annotated[
        Annotated[
            Optional[Literal["ODOS_SWAP"]], AfterValidator(validate_const("ODOS_SWAP"))
        ],
        pydantic.Field(alias="action_type"),
    ] = "ODOS_SWAP"
